/*################################################################################
# Linux Management Providers (LMP), DHCP provider package
# Copyright (C) 2009 Khahramon NURIDDINOV, qahramon0786@gmail.com,TUIT
# 
# This program is being developed under the "OpenDRIM" project.
# The "OpenDRIM" project web page: http://opendrim.sourceforge.net
# The "OpenDRIM" project mailing list: opendrim@googlegroups.com
# 
# This program is free software; you can redistribute it and/or
# modify it under the terms of the GNU General Public License
# as published by the Free Software Foundation; version 2
# of the License.
# 
# This program is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
# GNU General Public License for more details.
# 
# You should have received a copy of the GNU General Public License
# along with this program; if not, write to the Free Software
# Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA  02110-1301, USA.
#################################################################################

#################################################################################
# To contributors, please leave your contact information in this section
# AND comment your changes in the source code.
# 
# Modified by 2009 Guillaume BOTTEX, ETRI <guillaumebottex@etri.re.kr, guillaumebottex@gmail.com>
################################################################################*/

#ifndef OPENDRIM_DHCP2IPACCESS_H_
#define OPENDRIM_DHCP2IPACCESS_H_

#include "DHCP_Common.h"

#include "OpenDRIM_DHCP2IP.h"
#include "assocOpenDRIM_DHCP2IP.h"

int DHCP_OpenDRIM_DHCP2IP_load(const CMPIBroker* broker, string& errorMessage);

int DHCP_OpenDRIM_DHCP2IP_unload(string& errorMessage);

int DHCP_OpenDRIM_DHCP2IP_retrieve(const CMPIBroker* broker, const CMPIContext* ctx, vector<OpenDRIM_DHCP2IP>& instances, const char** properties, string& errorMessage, const string& discriminant);

int DHCP_OpenDRIM_DHCP2IP_getInstance(const CMPIBroker* broker, const CMPIContext* ctx, OpenDRIM_DHCP2IP& instance, const char** properties, string& errorMessage);

int DHCP_OpenDRIM_DHCP2IP_setInstance(const CMPIBroker* broker, const CMPIContext* ctx, const OpenDRIM_DHCP2IP& newInstance, const OpenDRIM_DHCP2IP& oldInstance, const char** properties, string& errorMessage);

int DHCP_OpenDRIM_DHCP2IP_createInstance(const CMPIBroker* broker, const CMPIContext* ctx, const OpenDRIM_DHCP2IP& instance, string& errorMessage);

int DHCP_OpenDRIM_DHCP2IP_deleteInstance(const CMPIBroker* broker, const CMPIContext* ctx, const OpenDRIM_DHCP2IP& instance, string& errorMessage);

int DHCP_OpenDRIM_DHCP2IP_associatorAntecedentToDependent(const CMPIBroker* broker, const CMPIContext* ctx, const Instance& Antecedent_instance, const char** properties, vector<Instance>& Dependent_associatedInstances, string& errorMessage, const string& discriminant);

int DHCP_OpenDRIM_DHCP2IP_associatorDependentToAntecedent(const CMPIBroker* broker, const CMPIContext* ctx, const Instance& Dependent_instance, const char** properties, vector<Instance>& Antecedent_associatedInstances, string& errorMessage, const string& discriminant);

int DHCP_OpenDRIM_DHCP2IP_referenceAntecedentToDependent(const CMPIBroker* broker, const CMPIContext* ctx, const Instance& Antecedent_instance, const vector<Instance>& Dependent_instances, vector<OpenDRIM_DHCP2IP>& OpenDRIM_DHCP2IP_instances, const char** properties, string& errorMessage, const string& discriminant);

int DHCP_OpenDRIM_DHCP2IP_referenceDependentToAntecedent(const CMPIBroker* broker, const CMPIContext* ctx, const Instance& Dependent_instance, const vector<Instance>& Antecedent_instances, vector<OpenDRIM_DHCP2IP>& OpenDRIM_DHCP2IP_instances, const char** properties, string& errorMessage, const string& discriminant);

int DHCP_OpenDRIM_DHCP2IP_populate(OpenDRIM_DHCP2IP& instance, string& errorMessage);

#endif /*OPENDRIM_DHCP2IPACCESS_H_*/
