/*################################################################################
# Linux Management Providers (LMP), DHCP provider package
# Copyright (C) 2009 Khahramon NURIDDINOV, qahramon0786@gmail.com,TUIT
# 
# This program is being developed under the "OpenDRIM" project.
# The "OpenDRIM" project web page: http://opendrim.sourceforge.net
# The "OpenDRIM" project mailing list: opendrim@googlegroups.com
# 
# This program is free software; you can redistribute it and/or
# modify it under the terms of the GNU General Public License
# as published by the Free Software Foundation; version 2
# of the License.
# 
# This program is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
# GNU General Public License for more details.
# 
# You should have received a copy of the GNU General Public License
# along with this program; if not, write to the Free Software
# Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA  02110-1301, USA.
#################################################################################

#################################################################################
# To contributors, please leave your contact information in this section
# AND comment your changes in the source code.
# 
# Modified by 2009 Guillaume BOTTEX, ETRI <guillaumebottex@etri.re.kr, guillaumebottex@gmail.com>
################################################################################*/

#ifndef CMPIOPENDRIM_DHCPPROTOCOLENDPOINT_H_
#define CMPIOPENDRIM_DHCPPROTOCOLENDPOINT_H_

#include "OpenDRIM_DHCPProtocolEndpoint.h"

CMPIObjectPath* DHCP_OpenDRIM_DHCPProtocolEndpoint_toCMPIObjectPath(const CMPIBroker* broker, const OpenDRIM_DHCPProtocolEndpoint& instance);

CMPIInstance* DHCP_OpenDRIM_DHCPProtocolEndpoint_toCMPIInstance(const CMPIBroker* broker, const OpenDRIM_DHCPProtocolEndpoint& instance);

void DHCP_OpenDRIM_DHCPProtocolEndpoint_toCPP(const CMPIBroker* broker, const CMPIObjectPath* ref, OpenDRIM_DHCPProtocolEndpoint& instance);

void DHCP_OpenDRIM_DHCPProtocolEndpoint_toCPP(const CMPIBroker* broker, const CMPIInstance* ci, OpenDRIM_DHCPProtocolEndpoint& instance);

void DHCP_OpenDRIM_DHCPProtocolEndpoint_toCPP(const CMPIBroker* broker, const CMPIArgs* in, OpenDRIM_DHCPProtocolEndpoint_RequestStateChange_In& args);

void DHCP_OpenDRIM_DHCPProtocolEndpoint_toCMPIArg(const CMPIBroker* broker, CMPIArgs* out, const OpenDRIM_DHCPProtocolEndpoint_RequestStateChange_Out& args);


#endif /*CMPIOPENDRIM_DHCPPROTOCOLENDPOINT_H_*/
