/*################################################################################
# Linux Management Providers (LMP), DHCP provider package
# Copyright (C) 2009 Khahramon NURIDDINOV, qahramon0786@gmail.com,TUIT
# 
# This program is being developed under the "OpenDRIM" project.
# The "OpenDRIM" project web page: http://opendrim.sourceforge.net
# The "OpenDRIM" project mailing list: opendrim@googlegroups.com
# 
# This program is free software; you can redistribute it and/or
# modify it under the terms of the GNU General Public License
# as published by the Free Software Foundation; version 2
# of the License.
# 
# This program is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
# GNU General Public License for more details.
# 
# You should have received a copy of the GNU General Public License
# along with this program; if not, write to the Free Software
# Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA  02110-1301, USA.
#################################################################################

#################################################################################
# To contributors, please leave your contact information in this section
# AND comment your changes in the source code.
# 
# Modified by 2009 Guillaume BOTTEX, ETRI <guillaumebottex@etri.re.kr, guillaumebottex@gmail.com>
################################################################################*/

#ifndef OPENDRIM_DHCPSERVERACCESS_H_
#define OPENDRIM_DHCPSERVERACCESS_H_

#include "DHCP_Common.h"

#include "OpenDRIM_DHCPServer.h"

int DHCP_OpenDRIM_DHCPServer_load(const CMPIBroker* broker, string& errorMessage);

int DHCP_OpenDRIM_DHCPServer_unload(string& errorMessage);

int DHCP_OpenDRIM_DHCPServer_retrieve(const CMPIBroker* broker, const CMPIContext* ctx, vector<OpenDRIM_DHCPServer>& instances, const char** properties, string& errorMessage, const string& discriminant);

int DHCP_OpenDRIM_DHCPServer_getInstance(const CMPIBroker* broker, const CMPIContext* ctx, OpenDRIM_DHCPServer& instance, const char** properties, string& errorMessage);

int DHCP_OpenDRIM_DHCPServer_setInstance(const CMPIBroker* broker, const CMPIContext* ctx, const OpenDRIM_DHCPServer& newInstance, const OpenDRIM_DHCPServer& oldInstance, const char** properties, string& errorMessage);

int DHCP_OpenDRIM_DHCPServer_createInstance(const CMPIBroker* broker, const CMPIContext* ctx, const OpenDRIM_DHCPServer& instance, string& errorMessage);

int DHCP_OpenDRIM_DHCPServer_deleteInstance(const CMPIBroker* broker, const CMPIContext* ctx, const OpenDRIM_DHCPServer& instance, string& errorMessage);

int DHCP_OpenDRIM_DHCPServer_RequestStateChange(const CMPIBroker* broker, const CMPIContext* ctx, const OpenDRIM_DHCPServer& instance, unsigned int& returnValue, const OpenDRIM_DHCPServer_RequestStateChange_In& in, OpenDRIM_DHCPServer_RequestStateChange_Out& out, string& errorMessage);

int DHCP_OpenDRIM_DHCPServer_populate(OpenDRIM_DHCPServer& instance, string& errorMessage);

#endif /*OPENDRIM_DHCPSERVERACCESS_H_*/
